<?php
/* vim: set noexpandtab tabstop=2 softtabstop=2 shiftwidth=2: */

// TrackMania Aseco/RASP Trivia Game version 0.92a
// chat.trivia.php : the plugin
// 2009 - by xOr
// 
// anything may be modified as long as you don't remove my name from this mess !
// 
Aseco::registerEvent('onSync', 'TriviaInit');
Aseco::registerEvent('onNewChallenge', 'TriviaOn');
Aseco::registerEvent('onEndRace', 'TriviaOff');
Aseco::registerEvent('onNewChallenge2', 'chat_showscore');
Aseco::registerEvent('onEverySecond', 'TickCount');

Aseco::addChatCommand('tv', 'Votes for a track, requires parameter (0-10)');
Aseco::addChatCommand('showscore', 'Shows score of a track');

//
// Every second this function is called, it makes sure the question is 
// the last thing aseco will display at a startround
//
function TickCount($aseco)
{
global $SecCount;
global $MaxCount;
		
		if ($SecCount == $MaxCount){
			showQuestion($aseco);
			$SecCount = 0;
		}
		else $SecCount++;
		
}

function resetVars()
{
global $TriviaEnable;
global $Running;
global $curQuestion;
global $curOptionA;
global $curOptionB;
global $curOptionC;			
global $curVoteAnswer;	
global $NumVoteFlags;
global $Displayed;
global $Mode;
global $MaxCount;

			$TriviaEnable = false; 
			$Running = false;
			$MaxCount = 20;	
			$NumVoteFlags = 0;
			$curQuestion = "";
			$curOptionA = "";
			$curOptionB = "";
			$curOptionC = "";										
			$curVoteAnswer = "";
			getQuestion("", "", "", "", "", "MODE_RESET");
			$Mode = "MODE_RANDOM";
			$TriviaEnable = false; 
			$Displayed = false;
	
}
				
//
// get a question from the database
//
function getQuestion($mode)
{
global $TriviaEnable;
global $Running;
global $curQuestion;
global $curOptionA;
global $curOptionB;
global $curOptionC;			
global $curVoteAnswer;	

static $curQuestionIndex = 0;

	$Filename = "./plugins/trivia.txt";
	$symbols = array("\n", "\r"); 
	
	$File = file($Filename);
	$numQuestions = count($File) / 6;
	
	if (($mode == "MODE_NORMAL") || ($mode == "MODE_NORMAL_LOOP")){	// cycle through each question in the list in single question mode
	
	 	$curQuestion = str_replace($symbols, "", $File[$curQuestionIndex + 1]);
	 	$curOptionA = str_replace($symbols, "", $File[$curQuestionIndex + 2]);
	 	$curOptionB = str_replace($symbols, "", $File[$curQuestionIndex + 3]);
	 	$curOptionC = str_replace($symbols, "", $File[$curQuestionIndex + 4]);						
	 	$curVoteAnswer = str_replace($symbols, "", $File[$curQuestionIndex + 5]);
		$curVoteAnswer = strtolower($curVoteAnswer);
		
		$curQuestionIndex++;
		if ($curQuestionIndex == $numQuestions){
			$curQuestionIndex = 0; // reset counter
		}
	}
	else if (($mode == "MODE_RANDOM") || ($mode == "MODE_RANDOM_LOOP")){ // randomly choose a question from the list in single question mode

		$luckyNumber = mt_rand(0, ($numQuestions-1));
      	$CurIndex = 6 * $luckyNumber;

	 	$curQuestion = str_replace($symbols, "", $File[$CurIndex + 1]);
	 	$curOptionA = str_replace($symbols, "", $File[$CurIndex + 2]);
	 	$curOptionB = str_replace($symbols, "", $File[$CurIndex + 3]);
	 	$curOptionC = str_replace($symbols, "", $File[$CurIndex + 4]);						
	 	$curVoteAnswer = str_replace($symbols, "", $File[$CurIndex + 5]);					 			
		$curVoteAnswer = strtolower($curVoteAnswer);
		
	}	
	else if ($mode == "MODE_RESET"){
		$curQuestionIndex = 0;
	}
	else {
		//echo "else .....(not good!)\n\r";
	}

}

//
// get score from mysql database
//
function getScore($login)
{
	$query = 'SELECT TriviaScore FROM players
	          WHERE login=' . quotedString($login);
			  
	$result = mysql_query($query);
	$TriviaScore = mysql_fetch_row($result);
		
 return $TriviaScore[0];
}

//
// increase score of $login by 1 and write to mysql database
//
function updateScore($login)
{
	$PreviousScore = getScore($login);
	$NewScore = $PreviousScore + 1;
		
	$query = "UPDATE players SET TriviaScore=$NewScore
	          WHERE login=" . quotedString($login);
			  
	$result = mysql_query($query);
		
 return $NewScore;
}


function showQuestion($aseco)
{
global $TriviaEnable;
global $Displayed;
global $Running;
global $curQuestion;
global $curOptionA;
global $curOptionB;
global $curOptionC;	
global $QuestionMsg;

	if ($TriviaEnable){
		if (($Running) && (!$Displayed)){ 

			// replace parameters
			$message = formatText(  $QuestionMsg,
									$curQuestion,
									$curOptionA, 
									$curOptionB,
									$curOptionC
							     );
		
			$aseco->client->query('ChatSendServerMessage', $aseco->formatColors($message));	
			$Displayed = true;
		}
	}
}


//
// start a round
//
function startRound($aseco)
{
global $Running;
global $SecCount;
global $Mode;
	
	getQuestion($Mode);
	
	$SecCount = 0;
	$Running = true;
}


function chat_showscore($aseco, $command)
{
global $TriviaEnable;
global $PointsMsg;
	
 if ($TriviaEnable){
	$query = 'SELECT NickName, TriviaScore FROM players
	          ORDER BY TriviaScore DESC LIMIT 3';
	$result = mysql_query($query);
	
	if (mysql_num_rows($result) > 0){ 
		$CurUser = mysql_fetch_row($result);
		$User1 = $CurUser[0];
		$Points1 = $CurUser[1];

		if (mysql_num_rows($result) > 1){		
			$CurUser = mysql_fetch_row($result);	
			$User2 = $CurUser[0];
			$Points2 = $CurUser[1];
			
			if (mysql_num_rows($result) > 2){		
				$CurUser = mysql_fetch_row($result);	
				$User3 = $CurUser[0];
				$Points3 = $CurUser[1];
			}
		}

		// replace parameters
		$message = formatText(  $PointsMsg,
								$User1, $Points1,
								$User2, $Points2,
								$User3, $Points3								
						     );
		
		$aseco->client->query('ChatSendServerMessage', stripColors($message));	
	}
 }
}

//
// Set the 'already voted' flag for $login
//
function SetVoteFlag($login)
{
global $VoteFlags;
global $NumVoteFlags;

	$VoteFlags[$NumVoteFlags++] = $login;
}

//
// See if the 'already voted' flag is set for $login
//
function HasVoteFlag($login)
{
global $VoteFlags;
global $NumVoteFlags;
 
 for ($i=0; $i<$NumVoteFlags; $i++){
 	if (!strcmp($VoteFlags[$i], $login)){
	 return true;
	}
 }
 
 return false;
}

//
// onNewChallenge
//
function TriviaOn($aseco)
{
global $TriviaEnable;
global $Displayed;
global $NumVoteFlags;
global $Running;

 if ($TriviaEnable){
	if (!$Running){
		$Displayed = false;	
		$NumVoteFlags = 0;			
		startRound($aseco);		
		$Running = true;			
	}
 }
 
}

//
// onEndRace
//
function TriviaOff($aseco)
{
global $TriviaEnable;
global $Displayed;
global $Running;

 if ($TriviaEnable){
	if ($Running){	
		$Displayed = true;			
		$Running = false;
	}
 }
 
}

//
// do the trick
//
function chat_tv($aseco, $command)
{
include('includes/trivia.config.php'); // bad place, but seems the only way to work this out ...

global $TriviaEnable;
global $Running;
global $curQuestion;
global $curOptionA;
global $curOptionB;
global $curOptionC;			
global $curVoteAnswer;	
global $NumVoteFlags;
global $Displayed;
global $Mode;
global $MaxCount;
 	
	$symbols = array("\n", "\r");
	$login = $command['author']->login;
	
	$admin = $command['author'];	
	$isAdmin = $aseco->isAdmin($admin);
	
	/*decode commands */	
	$curParam = "";
	$curParam2 = "";	
	$curCommand = "";
	$userFound = false;	
	$paramFound = false;
	
	for ($i = 0; $i<strlen($command['params']); $i++){
	
    		if (($command['params'][$i] == ' ') && ($userFound == false) && ($paramFound == false)){
			$userFound = true;
		}
	        else if (($command['params'][$i] == ' ') && ($paramFound == false) && ($userFound == true)){
			$paramFound = true;						
		}
		else if (($userFound == false) && ($paramFound == false)){
			$curCommand .= $command['params'][$i];
		}
		else if (($userFound == true) && ($paramFound == false)){
  			$curParam .= $command['params'][$i];	
		}
		else {
  		    $curParam2 .= $command['params'][$i];		    			
		}
    }

	$curCommand = strtolower($curCommand);
	$curParam = strtolower($curParam);	

 	$curParam2 = str_replace($symbols, "", $curParam2);
	$curParam2 = strtolower($curParam2);	
	
	if ($curCommand == "help"){
		$aseco->client->query('ChatSendServerMessageToLogin', $aseco->formatColors($TriviaHelp), $login);
	} 
	else if (($curCommand == "reset") || ($curCommand == "re")){	/* RESET */
		if ($isAdmin){

			$WasEnabled = $TriviaEnable; // keep enabled status after reset
			resetVars();
			
			$message = $ResetMsg;
			$aseco->client->query('ChatSendServerMessage', $aseco->formatColors($message));	
			
			$TriviaEnable = $WasEnabled;
		}
		return;	
	}		
	else if (($curCommand == "enable") && ($TriviaEnable == false)){	/* ENABLE */
		if ($isAdmin){

			resetVars();
	
			if ($curParam2){
				if (is_numeric($curParam2)){
					$MaxCount = (int) $curParam2;
				}
				else {
					$message = $InvalidTimeoutMsg;
					$aseco->client->query('ChatSendServerMessage', $aseco->formatColors($message));	
					return;			
				}
			}
			else {
					$MaxCount = $cycletime;
			}

			$message = $EnableMsg; // set default enable message			
		
			if($curParam == "random"){
					$Mode = "MODE_RANDOM";
					$message .= "\$z\$fff (Random mode (ct: $MaxCount sec))\$f00!\$fff";
			}
			else if($curParam == "randomloop"){
					$Mode = "MODE_RANDOM_LOOP";
					$message .= "\$z\$fff (Random Loop mode (ct: $MaxCount sec))\$f00!\$fff";										
			}
			
			else if($curParam == "normalloop"){
					$Mode = "MODE_NORMAL_LOOP";
					$message .= "\$z\$fff (Normal Loop mode (ct: $MaxCount sec))\$f00!\$fff";					
			}
			
			else if($curParam == "normal"){
					$Mode = "MODE_NORMAL";
					$message .= "\$z\$fff (Normal mode (ct: $MaxCount sec))\$f00!\$fff";						
								
			}
			else {  // default mode from config
					$Mode = $startup_mode;
					$message .= "\$z\$fff (Random mode (ct: $MaxCount sec))\$f00!\$fff";;										
			}
			
			$TriviaEnable = true;		
			$aseco->client->query('ChatSendServerMessage', $aseco->formatColors($message));				
		}
		return;	
	}	
	else if (($curCommand == "enable") && ($TriviaEnable == true)){
		if ($isAdmin){		
			$message = $AlreadyEnabledMsg;
			$aseco->client->query('ChatSendServerMessageToLogin', $aseco->formatColors($message), $login);		
		}
		return;		
	}	
	else if (($curCommand == "disable") && ($TriviaEnable == true)){ /* DISABLE */
		if ($isAdmin){	
			$TriviaEnable = false;

			resetVars();
			
			$message = $DisableMsg;
			$aseco->client->query('ChatSendServerMessage', $aseco->formatColors($message));					
		}
		return;	
	}
	else if (($curCommand == "disable") && ($TriviaEnable == false)){
		if ($isAdmin){								
			$message = $AlreadyDisabledMsg;
			$aseco->client->query('ChatSendServerMessageToLogin', $aseco->formatColors($message), $login);		
		}
		return;
	}		
	else if ($TriviaEnable){
			if (($curCommand == "getscore") || ($curCommand == "gs")){	/* GETSCORE */
			
				$TriviaScore = getScore($login);
				
				$message = formatText(  $ScoreMsg,
										$TriviaScore
									 );
									  
				$aseco->client->query('ChatSendServerMessageToLogin', $aseco->formatColors($message), $login);
				return;		
			}
			else if ((($curCommand == "getquestion") || ($curCommand == "gq")) && ($Running) && ($Displayed)){/* GETQUESTION */

				$message = formatText(  $QuestionMsg,
										$curQuestion,
										$curOptionA, 
										$curOptionB,
										$curOptionC
							    	 );
			
				$aseco->client->query('ChatSendServerMessageToLogin', $aseco->formatColors($message), $login);
				return;		
			}	
			else if ((($curCommand == "getquestion") || ($curCommand == "gq")) && ($Running) && (!$Displayed)){

				$message = $NoQuestionMsg;
				$aseco->client->query('ChatSendServerMessageToLogin', $aseco->formatColors($message), $login);
				return;		
			}	
    			else if ((($curCommand == "getquestion") || ($curCommand == "gq")) && (!$Running)){
				$message = $NoQuestionMsg;
				$aseco->client->query('ChatSendServerMessageToLogin', $aseco->formatColors($message), $login);
				return;					
			}
			else if ((($curCommand == "forcestart") || ($curCommand == "fs")) && (!$Running)){ /* FORCE START */
				if ($isAdmin){											
					$NumVoteFlags = 0; // reset vote flags
					$Displayed = false;	
					startRound($aseco);

					$message = $RoundStartedMsg;
					$aseco->client->query('ChatSendServerMessageToLogin', $aseco->formatColors($message), $login);
				}
				return;
			}	
			else if ((($curCommand == "forcestart") || ($curCommand == "fs")) && ($Running)){
				if ($isAdmin){				
					$message = $AlreadyStartedMsg;
					$aseco->client->query('ChatSendServerMessageToLogin', $aseco->formatColors($message), $login);
				}
				return;				
			}
			else if (($curCommand == "stop") && ($Running)){ // abort current round
				if ($isAdmin){	
					$Running = false;				
					$message = $RoundAbortedMsg;
					$aseco->client->query('ChatSendServerMessageToLogin', $aseco->formatColors($message), $login);
				}
				return;				
			}		
			else if (($curCommand == "stop") && (!$Running)){
				if ($isAdmin){				
					$message = $NoRoundRunning;
					$aseco->client->query('ChatSendServerMessageToLogin', $aseco->formatColors($message), $login);
				}
				return;				
			}				
			else if ((($curCommand == "a") || ($curCommand == "b") || ($curCommand == "c")) && ($Running) && ($Displayed)){	// answer
		
				$answer = strtolower($curCommand);
				if (!HasVoteFlag($command['author']->login)) // if not already voted
				{
					if (!strcmp($answer, $curVoteAnswer)){	// good answer
						$user = $command['author']->nickname;
						$Score = updateScore($login);

						$message = formatText(  $WinRoundMsg,
												$user,
												$Score
											 );
									
						$aseco->client->query('ChatSendServerMessage', stripColors($message));						
						
    						$Running = false;
    						if (($Mode == "MODE_RANDOM_LOOP") || ($Mode == "MODE_NORMAL_LOOP")){
		    				    $NumVoteFlags = 0; // reset vote flags
						    $Displayed = false;	
						    startRound($aseco);
						}
						return;	
					}
					else {	// bad answer
						SetVoteFlag($command['author']->login);
						$message = $BadVoteMsg;
						$aseco->client->query('ChatSendServerMessageToLogin', $aseco->formatColors($message), $login);		
						return;	
					}
				}
				else { // already made a bad vote this round
						$message = $AlreadyVotedMsg;
						$aseco->client->query('ChatSendServerMessageToLogin', $aseco->formatColors($message), $login);		
						return;					
				}
				
			}
			
			else if ((($curCommand == "a") || ($curCommand == "b") || ($curCommand == "c")) && ($Running) && (!$Displayed)){	
				$message = $NoQuestionMsg;
				$aseco->client->query('ChatSendServerMessageToLogin', $aseco->formatColors($message), $login);
				return;					
			}
			else if ((($curCommand == "a") || ($curCommand == "b") || ($curCommand == "c")) && (!$Running)){ // answer but no question asked
				$message = $NoQuestionMsg;
				$aseco->client->query('ChatSendServerMessageToLogin', $aseco->formatColors($message), $login);
				return;					
			}	
			else { // no valid parameter
				$message = $NoValidParamMsg;
				$aseco->client->query('ChatSendServerMessageToLogin', $aseco->formatColors($message), $login);
				return;					
			}	
			
	}
	else { // trivia not enabled
			$message = $NotEnabledMsg;
			$aseco->client->query('ChatSendServerMessageToLogin', $aseco->formatColors($message), $login);
			return;		
	}
	
}

//
// is called on startup, inits the Trivia
//
function TriviaInit($aseco)
{ 

global $TriviaEnable;
global $Running;
global $Mode;
global $MaxCount;

global $PointsMsg;		
global $QuestionMsg; 		

include_once('includes/trivia.config.php');

	resetVars();

	// set vars from config
	$MaxCount = $cycletime; 
	$Mode = $startup_mode;

	$TriviaEnable = $trivia_enable ;
	$Running = $trivia_running;	
	
	if ($Running){
		startRound($aseco);	
	}
}